/* eslint-disable no-mixed-spaces-and-tabs */
<template>
  <div class="app-container">
    <div class="filter-container">
      <el-input v-model="keyword" placeholder="请输入内容关键词" class="filter-item"/>
      <el-button type="primary" class="filter-item" icon="el-icon-search" @click="btn_search">搜索</el-button>
      <el-button v-permission="'HY_add'" type="primary" class="filter-item" icon="el-icon-plus" @click="btn_add">添加</el-button>
    </div>

    <el-table v-loading="loading" :data="dataLists" border stripe>
      <el-table-column type="index" label="编号" align="center" fixed width="80"/>
      <el-table-column prop="step" label="步骤编号" align="center" min-width=""/>
      <el-table-column :show-overflow-tooltip="true" prop="content" label="内容" align="center" width="252"/>
      <el-table-column label="类型" align="center" min-width="">
        <template slot-scope="scope">
          {{ scope.row.optiontype | typeFilter }}
        </template>
      </el-table-column>
      <el-table-column label="字典名称" align="center" min-width="">
        <template slot-scope="scope">
          <div v-if="scope.row.optiontype==1">
            {{ scope.row.dictionaryname }}({{ scope.row.dictionarycode }})
          </div>

        </template>
      </el-table-column>
      <el-table-column label="选项内容" align="center" min-width="">
        <template slot-scope="scope">
          <div v-if="scope.row.optiontype==2">
            <span v-for="(item,index) in scope.row.options" :key="index">{{ item }},</span>
          </div>
        </template>
      </el-table-column>
      <el-table-column prop="createtime" label="创建时间" align="center" min-width=""/>
      <el-table-column label="操作" width="160" align="center" class-name="oparate_btn" fixed="right">
        <template slot-scope="scope">
          <el-button v-permission="'HY_edit'" size="mini" plain type="primary" @click="btn_edit(scope.row.id)">编辑</el-button>
          <el-button v-permission="'HY_delete'" size="mini" plain type="danger" @click="btn_delete(scope.row.id)">删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    <pagination
      v-show="pageParams.total > 0"
      :total="pageParams.total"
      :pageindex.sync="pageParams.pageindex"
      :pagesize.sync="pageParams.pagesize"
      class="pagination"
      @pagination="getList" />
  </div>
</template>

<script>

import { getChatLists, deleteLineChat } from '@/api/onLineChat/lineChatManage'
import addOrEditLineChat from './addOrEditLineChat'
import Pagination from '@/components/Pagination' // 对el-pagination 二次封装
export default {
  name: 'OnLineChat',
  components: {
    Pagination
  },
  filters: {
    typeFilter: function(val) {
      // 0无1系统字典2手输选项
      if (val === 0) {
        return '无'
      } else if (val === 1) {
        return '系统字典'
      } else {
        return '手输选项'
      }
    }
  },
  data() {
    return {
      loading: false,
      keyword: '',
      pageParams: {
        pageindex: 1, // 当前第几页
        pagesize: Number(this.$store.getters.serverConfig.PAGESIZE), // 每页几条数据
        total: 0 // 总共多少数据
      },
      dataLists: [] // 列表数据
    }
  },

  created() {
    this.getList()
    document.onkeyup = (e) => {
      if (e.keyCode === 13) {
        this.getList()
      }
    }
  },
  methods: {
    getList() {
      this.loading = true
      return new Promise(resolve => {
        const params = {
          pageindex: this.pageParams.pageindex, // 第几页
          pagesize: this.pageParams.pagesize, // 每页几条信息
          keyword: this.keyword // 关键词
        }
        getChatLists(params).then(response => {
          this.loading = false
          if (response.state.toLowerCase() === 'success') {
            this.pageParams.total = response.data.total
            this.dataLists = response.data.rows
          }
        })
        resolve()
      })
    },
    btn_search() {
      this.pageParams.pageindex = 1
      this.getList()
    },
    btn_add() {
      this.$layer.iframe({
        content: {
          content: addOrEditLineChat, // 传递的组件对象
          parent: this, // 当前的vue对象
          data: { 'rowid': '' }// props//该方法会自动添加一个key为layerid的值， 该值为创建层的id， 可以直接使用
        },
        area: ['40%', '500px'],
        title: '添加回复步骤'
      })
    },
    btn_edit(editId) {
      this.$layer.iframe({
        content: {
          content: addOrEditLineChat, // 传递的组件对象
          parent: this, // 当前的vue对象
          data: { 'rowid': editId }// props
        },
        area: ['40%', '550px'],
        title: '编辑回复步骤'
      })
    },
    btn_delete(editId) {
      this.$confirm('您确定要将此项从列表中删除吗?', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        deleteLineChat(editId).then(response => {
          if (response.state.toLowerCase() === 'success') {
            this.getList()
            this.$message.success('删除成功!')
          }
        })
      }).catch(() => {
        this.$message.info('已取消删除')
      })
    }
  }
}
</script>

<style rel="stylesheet/scss" lang="scss" scoped>

</style>
